# iscsi.extent.create

Create an iSCSI Extent.

When type is set to FILE, attribute filesize is used and it represents number of bytes. filesize if not zero should be a multiple of blocksize. path is a required attribute with type set as FILE.

With type being set to DISK, a valid ZFS volume is required.

insecure_tpc when enabled allows an initiator to bypass normal access control and access any scannable target. This allows xcopy operations otherwise blocked by access control.

xen is a boolean value which is set to true if Xen is being used as the iSCSI initiator.

ro when set to true prevents the initiator from writing to this LUN.

Type: object

##

Type: array
No Additional Items

#### Tuple Validation

##### Parameter 1: iscsi_extent_create

#### iscsi_extent_create

Type: object

iSCSI extent configuration data for creation.

No Additional Properties

##

#### Name

Type: string

Name of the iSCSI extent.

Must be at least `1` characters long

Must be at most `64` characters long

##

#### Type

Type: enum (of string) Default: "DISK"

Type of the extent storage backend.

##### Must be one of:

- "DISK"
- "FILE"

##

#### Disk

Default: null

Disk device to use for the extent or `null` if using a file.

## Any of

Type: string
Type: null

##

#### Serial

Default: null

Serial number for the extent or `null` to auto-generate.

## Any of

Type: string
Type: null

##

#### Path

Default: null

File path for file-based extents or `null` if using a disk.

## Any of

Type: string
Type: null

##

#### Filesize

Default: "0"

Size of the file-based extent in bytes.

## Any of

Type: string
Type: integer

##

#### Blocksize

Type: enum (of integer) Default: 512

Block size for the extent in bytes.

##### Must be one of:

- 512
- 1024
- 2048
- 4096

##

#### Pblocksize

Type: boolean Default: false

Whether to use physical block size reporting.

##

#### Avail Threshold

Default: null

Available space threshold percentage or `null` to disable.

## Any of

Type: integer

Value must be greater or equal to `1` and lesser or equal to `99`

Type: null

##

#### Comment

Type: string Default: ""

Optional comment describing the extent.

##

#### Insecure Tpc

Type: boolean Default: true

Whether to enable insecure Third Party Copy (TPC) operations.

##

#### Xen

Type: boolean Default: false

Whether to enable Xen compatibility mode.

##

#### Rpm

Type: enum (of string) Default: "SSD"

Reported RPM type for the extent.

##### Must be one of:

- "UNKNOWN"
- "SSD"
- "5400"
- "7200"
- "10000"
- "15000"

##

#### Ro

Type: boolean Default: false

Whether the extent is read-only.

##

#### Enabled

Type: boolean Default: true

Whether the extent is enabled and available for use.

##

#### Product Id

Default: null

Product ID string for the extent or `null` for default.

## Any of

Type: string

Must be at least `1` characters long

Must be at most `16` characters long

Type: null

##

#### iSCSITargetExtentEntry

Type: object

The created iSCSI extent configuration.

No Additional Properties

##

#### Id

Type: integer

Unique identifier for the iSCSI extent.

##

#### Name

Type: string

Name of the iSCSI extent.

Must be at least `1` characters long

Must be at most `64` characters long

##

#### Type

Type: enum (of string) Default: "DISK"

Type of the extent storage backend.

##### Must be one of:

- "DISK"
- "FILE"

##

#### Disk

Default: null

Disk device to use for the extent or `null` if using a file.

## Any of

Type: string
Type: null

##

#### Serial

Default: null

Serial number for the extent or `null` to auto-generate.

## Any of

Type: string
Type: null

##

#### Path

Default: null

File path for file-based extents or `null` if using a disk.

## Any of

Type: string
Type: null

##

#### Dataset

The ZFS dataset containing the file-based extent (e.g., 'tank/iscsi'). Returns `null` for non-FILE extent types (DISK, ZVOL) or if the FILE path cannot be resolved yet (encrypted dataset not unlocked, etc.). This is a read-only field automatically populated from "path".

## Any of

Type: string
Type: null

##

#### Relative Path

The path of the file-based extent relative to the dataset mountpoint (e.g., 'extents/lun0.img'). An empty string indicates the file is at the dataset root. Returns `null` for non-FILE types or if the path cannot be resolved yet. This is a read-only field automatically populated from "path".

## Any of

Type: string
Type: null

##

#### Filesize

Default: "0"

Size of the file-based extent in bytes.

## Any of

Type: string
Type: integer

##

#### Blocksize

Type: enum (of integer) Default: 512

Block size for the extent in bytes.

##### Must be one of:

- 512
- 1024
- 2048
- 4096

##

#### Pblocksize

Type: boolean Default: false

Whether to use physical block size reporting.

##

#### Avail Threshold

Default: null

Available space threshold percentage or `null` to disable.

## Any of

Type: integer

Value must be greater or equal to `1` and lesser or equal to `99`

Type: null

##

#### Comment

Type: string Default: ""

Optional comment describing the extent.

##

#### Naa

Type: string

Network Address Authority (NAA) identifier for the extent.

Must be at most `34` characters long

##

#### Insecure Tpc

Type: boolean Default: true

Whether to enable insecure Third Party Copy (TPC) operations.

##

#### Xen

Type: boolean Default: false

Whether to enable Xen compatibility mode.

##

#### Rpm

Type: enum (of string) Default: "SSD"

Reported RPM type for the extent.

##### Must be one of:

- "UNKNOWN"
- "SSD"
- "5400"
- "7200"
- "10000"
- "15000"

##

#### Ro

Type: boolean Default: false

Whether the extent is read-only.

##

#### Enabled

Type: boolean Default: true

Whether the extent is enabled and available for use.

##

#### Vendor

Type: string

Vendor string reported by the extent.

##

#### Product Id

Default: null

Product ID string for the extent or `null` for default.

## Any of

Type: string

Must be at least `1` characters long

Must be at most `16` characters long

Type: null

##

#### Locked

Read-only value indicating whether the iscsi extent is located on a locked dataset.

- `true`: The extent is in a locked dataset.
- `false`: The extent is not in a locked dataset.
- `null`: Lock status is not available because path locking information was not requested.

## Any of

Type: boolean
Type: null

Required roles: SHARING_ISCSI_EXTENT_WRITE